#!/usr/bin/perl
BEGIN{
#LIBPATH is where VBS.pl is located
 $LIBPATH="../Lib";
#*********VERIFY THE ABOVE VALUES************
 unshift(@INC,$LIBPATH);
}
use CGI;
$query = new CGI;
require "VBS.pl";

($boardname)=$query->keywords;
if(!$boardname){$boardname=$query->param(boardname);}
$boardname=~/(\w+)/;
$boardname=$1;
$boardname=~s/\.defs//;
require "$boardname.defs";

&GetValues();
&PrintInput();
&PrintMap();
exit;

sub GetValues {
 $typemsg=$query->param(typemsg);
 if($typemsg){
  $typemsg=~/(ALL|TEXT|HTML|URL|FILE)/;
  $typemsg=$1;
 }
 $dvalue=$query->param(dvalue);
 if($dvalue){
  $dvalue=~/(\d+)/;
  $dvalue=$1;
 }
 $tvalue=$query->param(tvalue);
 if($tvalue){
  $tvalue=~/(D|W|M|Y)/;
  $tvalue=$1;
  if($tvalue=~/^D$/){$tvalue=60*24;}
  elsif($tvalue=~/^W$/){$tvalue=60*24*7;}
  elsif($tvalue=~/^M$/){$tvalue=60*24*30;}
  elsif($tvalue=~/^Y$/){$tvalue=60*24*365;}
 }
}

sub PrintInput {
 %tarray=('D'=>'Day(s)',
		'W'=>'Week(s)',
		'M'=>'Month(s)',
		'Y'=>'Year(s)');
 print $query->header,
	"<CENTER><H2>$ORGANIZATION\'s VBS Site Map</H2></CENTER>\n",
	"<HR SIZE=3>\n",
	$query->start_form(-name=>'map',
		-method=>"$METHOD",
		-action=>"$MAPSCRIPT"),
	"\n",
	"<B>Show messages of type: </B>\n",
	$query->radio_group(-name=>'typemsg',
		-values=>['ALL','TEXT','HTML','URL','FILE'],
		-default=>'ALL'),
	"<P>\n",
	"<B>For the last: </B>\n",
	$query->popup_menu(-name=>'dvalue',-values=>[1..10]),
	" ",
	$query->popup_menu(-name=>'tvalue',-values=>['D','W','M','Y'],
		-labels=>\%tarray, -default=>'D'),
	"<BR>\n",
	$query->submit(-name=>'todo', -value=>'MAP'),
	"<HR SIZE=3>\n",
	"<CENTER><H3>Message of type: <B>$typemsg</B><BR>",
	"For the last <B>$dvalue ",
	$tarray{'$tvalue'},
	" </B></H3></CENTER>";
}
 

sub PrintMap {
 (*harray,*harraynums)=&GetArray("h",0,0);
 #@harray=@ha;@harraynums=@hanums;
 print "<UL>\n";
 foreach $hnumber (@harraynums){
  print shift(@harray);
  (*sarray,*sarraynums)=&GetArray("s",0,$hnumber);
 # @sarray=@sa;@sarraynums=@sanums;
  print "\n<UL>\n";
  foreach $snumber (@sarraynums){
   print shift(@sarray);
   (*tarray)=&GetArray("t",$hnumber,$snumber);
   print @tarray;
  }
  print "</UL>\n";
 }
 print "</UL>\n";
 return;
}

sub GetArray {
#$type = [h/s/t] heads/subheads/titles
#$grandparent = grandparent
#$parent = parent
 my($type,$grandparent,$parent)=@_;
 local(@array)=();
 local(@arraynums)=();
 if($type eq "h"){
  open(DOC,"$DISKNEWSPATH/hmain.html") || die "Can't open hmain: $!\n";
 }
 elsif($type eq "s"){
  open(DOC,"$DISKNEWSPATH/$parent/smain.html") || die "Can't open $DISKNEWSPATH/$parent/smain: $!\n";
 }
 elsif($type eq "t" && $grandparent && $parent){
  open(DOC,"$DISKNEWSPATH/$grandparent/$parent/tmain.html") || die "Can't open tmain: $!\n";
 }
WHILE0:	while(<DOC>){
  if(/^<!--START-->$/){
WHILE1:	while(<DOC>){
    if(/^<!--STOP-->$/){last WHILE0;}
    elsif($type ne "t" && /^<LI><a href="\d+\/"><!--\d+,\d+-->/){
     if($type eq "h"){
      s/^<LI><a href="\d+\/"><!--(\d+),\d+-->(.*)$/<LI><a href="$HTTPADDRESS\/$WEBNEWSPATH\/$1">$2/;
      $digit=$1;
     }
     elsif($type eq "s"){
      s/^<LI><a href="\d+\/"><!--(\d+),\d+-->(.*)$/<LI><a href="$HTTPADDRESS\/$WEBNEWSPATH\/$parent\/$1">$2/;
      $digit=$1;
     }
     push(@array,$_);
     push(@arraynums,$digit);
    }
    elsif($type eq "t"){
     if(/^<LI>(.*)<a href="\d+\.(.*)"><!--(\d+),(\d+)-->(.*)$/){
      $new=qq%<LI>$1<a href="$HTTPADDRESS\/$WEBNEWSPATH\/$grandparent\/$parent\/$3.$2">$5%;
      $olddate=$4;
      if($olddate >= $newdate){
       push(@array,$new);
      }
     }
     else{push(@array,$_);}
    }
    else{next WHILE1;}
   } #End of WHILE1
  } #End of if START
  else{next WHILE0;}
 } #End of WHILE0
 close(DOC);
 return(\@array,\@arraynums);
}
