#!/usr/bin/perl
#Make sure these are correct
#LIBPATH is where VBS.pl is located
$LIBPATH="../Lib";
#    Copyright (C) 1996 - Brad Daughert (1/7/97) 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    The full license can be found at: 
#	http://www.pobox.com/~bsd/vbs/license.html
#


$name="Virtual Bulletin System";
$version="v5.0";
$uid=(getpwnam($YOURUSER))[2];
$gid=(getpwnam($WWWUSER))[3];

 print "\n\n";
 print "********* W E L C O M E *********\n";
 print "************** T O **************\n\n";
 print "$name $version\n\n";
 do { 
  print "What do you want to call the new VBS\n";
  print "(One Word - Characters & Numbers only)? => ";
  chomp($BOARDNAME=<STDIN>);
  if($BOARDNAME=~/\W+/){print "Sorry, illegal characters.\n";}
  if(-e "$BOARDPATH/$BOARDNAME.defs"){print "That name already exists\n";}
  if($BOARDNAME eq "minimum"){print "The board name can't be \"minimum\".\n";}
 }
  until (!-e "$BOARDPATH/$BOARDNAME.defs" && $BOARDNAME ne "minimum"
		&& $BOARDNAME=~/^\w+$/);
 print "Please enter a username for the VBS administrator => ";
 chomp($username = <STDIN>);
 print "Please enter a password for the VBS administrator => ";
 chomp($password = <STDIN>);
 $encpass=crypt("$password","$username");
 open(DOC,">$LIBPATH/$BOARDNAME.defs") || die "Can't open $BOARDPATH/$BOARDNAME.defs: $!";
 open(INPUT,"<$LIBPATH/DEFINITIONS.defs") || die "Can't open $LIBPATH/DEFINITIONS.defs: $!";
 print DOC<<END;
#DON'T CHANGE THE NEXT 7 LINE
#\$BOARDNAME is the name of the board.
\$BOARDNAME="$BOARDNAME";
#\$MASTERPASSWORD is the password that will allow an administrator to
# change anything on a board.
\$MASTERPASSWORD="$encpass";
#\$ADMINNAME is the username of the administrator
\$ADMINNAME="$username";
END
 while(<INPUT>){print DOC;}
 close(INPUT);
 close(DOC);
 if(!-e "$LIBPATH/minimum.defs"){
  system "cp", "$LIBPATH/MINIMUM.defs", "$LIBPATH/minimum.defs";
  chmod 0664, "$LIBPATH/$BOARDNAME.defs", "$LIBPATH/minimum.defs";
  chown $uid, $gid, "$LIBPATH/*";
 }
 print<<END;

Great,

	Your new board is on its way to a beautiful start.
Now please edit the files:

$LIBPATH/$BOARDNAME.defs
$LIBPATH/minimum.defs

Instructions are located inside of those files.  When you are finshed
editing please run the program "CreateFiles.pl $BOARDNAME".

Thanks,
Brad Daugherty
$name $version

P.S. You are currently the "WWW" user aren't you, or you are
	allowed to execute CGI scripts from your user
	account right?  If not please change the permissions
	on all VBS files or rerun this program as the "WWW" user.

END
exit;
