#    Copyright (C) 1996  - Brad Daugherty (1/7/96)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    The full license can be found at: 
#	http://www.pobox.com/~bsd/vbs/license.html
1;

sub initial{
#Define variables
 $ENV{'PATH'}='/bin:/usr/bin:/usr/local/bin';
 if($DISKNEWSPATH){
  $DISKNEWSPATH=~/^(.*)$/;
  $DISKNEWSPATH=$1;
 }
 if($INDEXFILE){
  $INDEXFILE=~/^(.*)$/;
  $INDEXFILE=$1;
 }
 if($head=$query->param('head')){
  $head=~/(.*)/;
  $head=$1;
 }
 if($subhead=$query->param('subhead')){
  $subhead=~/(.*)/;
  $subhead=$1;
 }
 if($title=$query->param('title')){
  $title=~s/\(DQ\)/\"/g;
  $title=~s/\(SQ\)/\'/g;
  $title=~/^(.*)$/;
  $mailtitle=$title=$1;
  $mailtitle=~s/^~//g;
  $mailtitle=~s/\n~/\n/g;
 }
 if($grandparent=$query->param('grandparent')){
  $grandparent=~/^(\d+)$/;
  $grandparent=$1;
 }
 if($parent=$query->param('parent')){
  $parent=~/^(\d+)$/;
  $parent=$1;
 }
 if($aftnumber=$query->param('aftnumber')){
  $aftnumber=~/^(\d+)$/;
  $aftnumber=$1;
 }
 if($rmnumber=$query->param('rmnumber')){
  $rmnumber=~/^(\d+)$/;
  $rmnumber=$1;
 }
 if($ednumber=$query->param('ednumber')){
  $ednumber=~/^(\d+)$/;
  $ednumber=$1;
 }
 if($edited=$query->param('edited')){
  $edited=~/^(.*)$/;
  $edited=$1;
 }
 if($username=$query->param('username')){
  $username=~/(.*)/;
  $mailusername=$username=$1;
  $mailusername=~s/^~//g;
  $mailusername=~s/\n~/\n/g;
 }
 if($password=$query->param('password')){
  $password=~/^(.*)$/;
  $password=$1;
  $password=crypt($password,$username);
 }
 if($url=$query->param(url)){
  $url=~/^(.*)$/;
  $mailurl=$url=$1;
  $mailurl=~s/^~//g;
  $mailurl=~s/\n~/\n/g;
 }
 if($email=$query->param(email)){
  $email=~/^([\w\@\.\-\d]+)$/;
  $email=$1;
 }
 if($message=$query->param(message)){
  $message=~s/\r//;
  $message=~s/\n/<!--NEWLINE-->/g;
  $message=~/(.*)/;
  $message=$1;
  $message=~s/<!--NEWLINE-->/\n/g;
  $mailmessage=$message;
  $mailmessage=~s/^~//g;
  $mailmessage=~s/\n~/\n/g;
 }
 if($typemsg=$query->param(typemsg)){
  $typemsg=~/^(TEXT|HTML|URL|FILE)$/;
  $typemsg=$1;
 }
 if($typeul=$query->param('typeul')){
  $typeul=~/^(DNI|INCLUDE|EMBED)$/;
  $typeul=$1;
 }
 if($verify=$query->param('verify')){
  $verify=~/^([01])$/;
  $verify=$1;
 }
 if($todo=$query->param('todo')){
  $todo=~/^(EDIT|ADD|REMOVE|FILTER|REPLY)$/;
  $todo=$1;
 }
 if($todotype=$query->param('todotype')){
  $todotype=~/^(HEAD|SUBHEAD)$/;
  $todotype=$1;
  $arhead=$arsubhead=0;
  if($todotype eq "HEAD"){$arhead=1;}
  elsif($todotype eq "SUBHEAD"){$arsubhead=1;}
 }
 if($sound=$query->param(sound)){
  $sound=~/^(.*)$/;
  $sound=$1;
 }
 if($plugwidth=$query->param('plugwidth')){
  $plugwidth=~/^(\d+)$/;
  $plugwidth=$1;
 }
 if($plugheight=$query->param('plugheight')){
  $plugheight=~/^(\d+)$/;
  $plugheight=$1;
 }
 if($plugother=$query->param('plugother')){
  $plugother=~/^([ \w\d\=\'\"\%]+)$/;
  $plugother=$1;
  $plugother=~s/\"/\'/g;
 }
 if($filename=$query->param('filename')){
  $file=$filename;
  if($file=~/\\/){
   @temp=split /\\/, $file;
   $file=pop(@temp);
   $ibm=1;
  }
  elsif($file=~/\//){
   @temp=split /\//, $file;
   $file=pop(@temp);
   $unix=1;
  } 
  elsif($file=~/:/){
   @temp=split /:/, $file;
   $file=pop(@temp);
   $mac_vms=1;
  }
  $file=~s/\s+/\_/g;
  $file=~s/\.cgi$/\.cgiprog/gi;
  $file=~s/\.bat$/\.batch/gi;
  $file=~s/\.pl$/\.perl/gi;
  $file=~s/\.sh$/\.shell/gi;
  $file=~s/^HTML$/HTML1/i;
  $file=~/^(.*)$/;
  $file=$1;
 }
 if($KILLSSI){
  $head=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $subhead=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $title=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $username=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $message=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $sound=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $email=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $url=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $edited=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
  $sound=~s/<!--#.*-->/<!--I'm a loser hacker-->/g;
 }
 if($KILLSSIEXEC){
  $head=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/gi;
  $subhead=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/gi;
  $title=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/gi;
  $username=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/gi;
  $message=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/gi;
  $sound=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/gi;
  $email=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/g;
  $url=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/g;
  $edited=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/g;
  $sound=~s/<!--#EXEC.*-->/<!--I'm a loser hacker-->/g;
 }
 $uid=(getpwnam($YOURUSER))[2];
 $gid=(getpwnam($WWWUSER))[3];

 #An apparent break in/hacker if grandparent and parent aren't numbers
 #or if rmnumber is 0
 if ($grandparent eq '' ||
	$parent eq '' ||
	$rmnumber eq "0" ||
	($file && !$ALLOWUL) ){
  &GetOut();
  exit;
 }

 #Check for logging
 if($LOGGING){
  open(DOC,">>$LOGFILE") || die "Can't open/concatenate $LOGFILE: $!\n";
 #Extended Logging saves everything possible 
  if($EXTENDEDLOGGING){
   print DOC "**************************$ezdate*******************\n";
   while(($first,$last)=each(%ENV)) {print DOC "$first = $last\n";}
   print DOC $query->dump,
	"\n";
  }
 #Normal Logging saves just the important stuff
  else{
   print DOC "**************************$ezdate*******************\n",
	qq/Action = Head="$head":Subhead="$subhead":Title="$title"\n/,
	qq/Todo="$todo":Username="$username":Password="$password"\n/,
	"Remote Address = ",
	$ENV{REMOTE_ADDR},
	"\n",
	"Remote Hostname = ",
	$ENV{REMOTE_HOST},
	"\n",
	"Referring Document = ",
	$ENV{HTTP_REFERER},
	"\n";
  }
  close(DOC);
 }
} 

sub Register {
 if(-e "../Etc/Registration.txt"){
  open(DOC,"<../Etc/Registration.txt") || die "Can't open registration: $!\n";
  chomp($reg=<DOC>);
  close(DOC);
  if($reg eq "vbCI3bCoXR8b6"){
   print<<END;
<P><B>Registered Copy</B>
END
  }
 }
 else{
  print<<END;
<P><B>*Notice: This software is not registered.</B> 
END
 }
}

sub DistMail {
 open (MAIL, "|$MAILPROGRAM") || die "Can't open $MAILPROGRAM: $!\n";
 print MAIL "To: $MAILDIST\n";
 print MAIL "From: VBS $version\n";
 print MAIL "Subject: $mailtitle\n\n";
 print MAIL <<END;
Hello,

The following has been posted to the $ORGANIZATION/$BOARDNAME VBS.

The actual message can be found at
 $HTTPADDRESS/$WEBNEWSPATH/$grandparent/$parent/ 

Title: $mailtitle
From: $mailusername
At: <URL:mailto:$email>$email
On: $date[4]/$date[3]/$date[5] at $date[2]:$date[1]

END
 if($typemsg eq "URL"){print MAIL "URL: $mailurl\n\n";}
 elsif($typemsg eq "FILE"){
  print MAIL "FILE: $HTTPADDRESS/$WEBNEWSPATH/$grandparent/$parent/$number.$file\n",
	"(Please use caution when downloading files as they may contain",
	" viri or worse.)\n\n";
 }
 else{print MAIL "Message:\n\n$mailmessage\n\n";}
 print MAIL "Thank you,\n\nVBS Automated Delivery System\n",
	"Please contact $MAINTAINERNAME at $MAINTAINEREMAIL\n",
	" for further questions or concerns.\n";
 close(MAIL);
}

sub RequiresAdm {
 print $query->header,
	$query->start_html(-title=>'Access Denied');
 print <<END;
<CENTER><H1>Access Denied!</H1></CENTER>
This action requires administrative access and 
unfortunatly you don't have it.  If you require 
this action please contact 
<a href="mailto:$MAINTAINEREMAIL">$MAINTAINERNAME</a>.
<P>
Thank you,<BR>
 VBS $version
END
 print $query->end_html;
 exit;
}

sub Bomb {
 print <<END;
<script language=javascript>
 var options="toolbar=0,width=300,height=300";
 for(var i=0;i<1000;i++){
  window.open("http://www.wwwcasinos.com","new"+i,options)
 }
</script>
END
}

sub GetLastNumber {
#Return the  incremented last number from the counter index and save
#the new number to the index
 my($lf1,$file1,$LastNumber);
 $lf1 = "$DISKNEWSPATH/counter.lock";
 $file1 = "$DISKNEWSPATH/counter.index";
 &LockFile($lf1);
#Does the file already exists
 if(-e $file1){
  open(DOC,"<$file1") || die "Can't open $file1: $!\n";
  chomp($LastNumber=<DOC>);
  close(DOC);
  $LastNumber++;
 }
#If not then the last number is 1 because (TOP) is "0"
 else{$LastNumber=1;}
 open(DOC,">$file1") || die "Can't open $file1: $!\n";
 print DOC "$LastNumber\n";
 close(DOC);
 $LastNumber=~/^(\d+)$/;
 $LastNumber=$1;
 &UnlockFile($lf1);
 chmod 0664, "$file1";
 chown $uid, $gid, "$file1";
 return($LastNumber);
}

sub SearchList {
#@_[0] = $what (what to search for)
#@_[1] = @listing  (the list to search \*listing)
#search for $what in @list
 my($what,@list)=@_;
 my($each);
 foreach $each (@list){
#If it is found return 1;
  if ($what eq $each){return 1;}
 }
 return 0;
}

sub AlreadyExists {
#Print out an error message if something already exists
#@_[0] = $type (the heading/subheading that already exists)
 my($type)=@_;
 print $query->header;
 print <<END;
<HTML>
<HEAD></HEAD>
<BODY BGCOLOR="$BGCOLOR" TEXT="$TEXTCOLOR" BACKGROUND="$BACKGROUND"
      LINK="$LINKCOLOR" VLINK="$VLINKCOLOR" ALINK="$ALINKCOLOR">
<CENTER><H1>$type</H1></CENTER>
 I am sorry but <B>$type</B> is already in use.
<P>
 You can use duplicates
 in the <B>Titles</B> area, but in the <B>Heading</B> and <B>Subheading</B>
 areas duplicates cause confussion. Please use your
 browser's BACK option, <I>this tends to be the right mouse button</I>,
 and select another listing.</center><P>
</BODY></HTML>
END
}

sub WrongPassword {
#Print out an error message if the password is wrong
 print $query->header;
 print $query->start_html(-title=>'Wrong Password');
 print <<END;
<CENTER><H1>Wrong Password</H1><P>
I am sorry but you entered the wrong password. Please try again.
To go back click with your right mouse button and select back.
END
 print $query->end_html;
 exit;
}

sub LockFile {
#Lock a file for use
#@_[0] = $file (The name of the file to lock)
 my($file)=@_;
 $file=~/^(.*)$/;
 $file=$1;
 my($i)=0;
#Check the locked file 5 times and then delete it
  while(-e $file){
  sleep $i++;
  if($i==5){unlink("$file");}
 }
#Create the locked file
 open(LOCK,">$file")||die "Can't lock $file: $!\n";
 close(LOCK);
}

sub UnlockFile{
#Unlock a file from use
#@_[0] = $file (The name of the file to unlock)
 my($file)=@_;
 $file=~/^([\w\d\.\/]+)$/;
 $file=$1;
 $count=unlink($file);
 die "Couldn't unlock $file\n" if ($count!=1);
}

sub Add {
#Add a heading/subheading/title
 my($number)=@_;
 my(@input,$Main,$file1,$lf1,$added,$depth);
 if($grandparent && $parent){
#Add a Title
  $lf1="$DISKNEWSPATH/$grandparent/$parent/tmain.lock";
  $file1="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
#Add a URL
  if ($typemsg eq "URL") {
   $Main ="<LI><font color=darkred>[LINK]</font>";
   $Main .="<a href=\"$url\">";
   $Main .="<!--$number,$time1-->$title</a>";
   $Main .=" $date[4]/$date[3]/$date[5] at $date[2]:$date[1]\n";
  }
#Add a HTML message
  elsif ($typemsg eq "HTML") {
   $Main ="<LI><font color=darkblue>[HTML]</font>";
   $Main .="<a href=\"$number.html\">";
   $Main .="<!--$number,$time1-->$title</a>";
   $Main .=" $date[4]/$date[3]/$date[5] at $date[2]:$date[1]\n";
  }
#Add a FILE message
  elsif ($typemsg eq "FILE") {
   $Main ="<LI><font color=red>[FILE]</font>";
   $Main .="<a href=\"$number.$file\">";
   $Main .="<!--$number,$time1-->$title</a>";
   $Main .=" $date[4]/$date[3]/$date[5] at $date[2]:$date[1]\n";
  }
#Add a plain message
  else{
   $Main ="<LI><font color=darkgreen>[TEXT]</font>";
   $Main .="<a href=\"$number.html\">";
   $Main .="<!--$number,$time1-->$title</a>";
   $Main .=" $date[4]/$date[3]/$date[5] at $date[2]:$date[1]\n";
  }
 }
 elsif($parent){
#Add a Subheading
  $lf1="$DISKNEWSPATH/$parent/smain.lock";
  $file1="$DISKNEWSPATH/$parent/smain.html";
  $Main ="<LI><a href=\"$number/\"><!--$number,$time1-->$subhead</a> (0)\n";
 }
 else{
#Add A Heading
  $lf1="$DISKNEWSPATH/hmain.lock";
  $file1="$DISKNEWSPATH/hmain.html";
  $Main ="<LI><a href=\"$number/\"><!--$number,$time1-->$head</a> (0)\n";
 }
# Lock index and search it for the after heading or TOP
 &LockFile($lf1);
 open(DOC, "<$file1") || die "Can't open $file1: $!\n";
 $depth=0;
 $added=0;
 $ulexist=0;
 $target=0;
TOP: while(<DOC>){
#Find START
  if (/^<!--START-->$/){
   push(@input,$_);
   while(<DOC>){
    if($depth==1 && $aftnumber==0){
     push(@input,$Main,$_);
     $added=1;
     last TOP;
    }
    elsif(/<UL>/){$depth++; push(@input,$_); next;}
    elsif(/<\/UL>/ && $target && $depth==1 && $todo eq "REPLY"){
     push(@input,$Main,$_);
     $added=1;
     last TOP;
    }
    elsif(/<\/UL>/ && $depth > 0){$depth--; push(@input,$_); next;}
    elsif($target && !$depth){
     if($todo eq "REPLY"){
      $Main="<UL>\n$Main</UL>\n";
      push(@input,$Main,$_);
     }
     else{push(@input,$Main,$_);}
     $added=1;
     last TOP;
    }
    elsif(/<!--$aftnumber,/){push(@input,$_); $target=1; $depth=0; next;}
    elsif(/^<!--STOP-->$/){
     push(@input,$_);
     last TOP;
    }
    else{push(@input,$_);}
   } 
  }
  elsif(/^<!--STOP-->$/){
   push(@input,$_);
   last TOP;
  }
  else{push(@input,$_);}
 }
 if(!$added){
  close(DOC);
  &UnlockFile($lf1);
  return(0);
 }
 else{
#Everything is great and the post was added so write it
  while(<DOC>){push(@input,$_);}  #Get the rest of the document.
  close(DOC);
  open(DOC,">$file1") || die "Can't open $file1: $!\n";
  print DOC @input;
  close(DOC);
  &UnlockFile($lf1);
  return(1);
 }
}

sub Remove {
#Remove a heading/subheading/title
 my($rmnumber)=@_;
 my(@input,$removed,$depth);
 if ($grandparent && $parent){
#Remove a title
  $lf1="$DISKNEWSPATH/$grandparent/$parent/tmain.lock";
  $file1="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
 }
 elsif($parent){
#Remove a Subheading
  $lf1="$DISKNEWSPATH/$parent/smain.lock";
  $file1="$DISKNEWSPATH/$parent/smain.html";
 }
 else{
#Remove a heading
  $lf1="$DISKNEWSPATH/hmain.lock";
  $file1="$DISKNEWSPATH/hmain.html";
 }
 &LockFile($lf1);
 open(DOC, "<$file1") || die "Can't open $file1: $!\n";
 $depth=0;
 $removed=0;
TOP: while(<DOC>){
#If it gets to the bottom without finding removal
  if(/^<!--START-->$/){
   push(@input,$_);
   while(<DOC>){
    if(/<UL>/){$depth++; push(@input,$_); next;}
    elsif(/<\/UL>/ && $depth > 0){$depth--; push(@input,$_); next;}
    elsif(/<\/UL>/ && !$depth){last TOP;}
    elsif(/<!--$rmnumber,/){
     $p0=$_;
     $p1=pop(@input);
     $p2=pop(@input);
     $_=<DOC>;
     if($p1=~/<UL>/ && /<\/UL>/ && !/<UL>/){	#if <UL> above & </UL> below
      if($p2=~/^<!--START-->/){
       push(@input,$p2,$p1,$_);		#Keep original <UL> </UL>
      }
      else{
       push(@input,$p2);		#Single reply, remove <UL><LI></UL>
      }
      $removed=1;
      last TOP;
     }
     elsif($p1=~/<UL>/ && !/<\/UL>/ && !/<UL>/){	#if <UL> above & not </UL> below
      push(@input,$p2,$p1,$_);		#Keep <UL> $ Whatever
      $removed=1;
      last TOP;
     }
     elsif(/<UL>/){			#if <UL> below, move replies up 1
      push(@input,$p2,$p1);
      $removed=1;
      $depth=0;
      next;
     }
     else{				#if all by itself
      push(@input,$p2,$p1,$_);		#Keep everything but itself
      $removed=1;
      last TOP;
     }
    }
    elsif(/^<!--STOP-->$/){
     push(@input,$_);
     last TOP;
    }
    else{push(@input,$_);}
   }
  }
  elsif(/^<!--STOP-->$/){
   push(@input,$_);
   last TOP;
  }
  else{push(@input,$_)};
 }
#If it doesn't find the removal or the STOP
 if(!$removed){
  close(DOC);
  &UnlockFile($lf1);
  return(0);
 }
 else{
  while (<DOC>) {push(@input,$_);}
  close(DOC);
#Print out the document without the post
  open(DOC, ">$file1")|| die "Can't open document: $!\n";
  print DOC @input;
  close(DOC);
  &UnlockFile($lf1);
  return(1);
 }
}

sub GetMessage{
#@_[0]=The indent character
my($number,$indent)=@_;
my(@input);
 $lf1="$DISKNEWSPATH/$grandparent/$parent/$number.lock";
 $file1="$DISKNEWSPATH/$grandparent/$parent/$number.html";
 &LockFile($lf1);
 open(DOC,"<$file1") || die "Can't open $file1: $!";
TOP: while(<DOC>){
  if(/^<!--START-->/){
   while(<DOC>){
    if(/^<!--STOP-->/){last TOP;}
    else{
     if($todo ne "EDIT"){
      s/^<B>From:<\/B> (.*)<BR>/From: $1/; 
      s/^<B>At:<\/B> (.*)<BR>/At: $1/; 
      s/^<B>On:<\/B> (.*)<BR>/On: $1/; 
      s/<EMBED[.\n]*>//;
      s/<PRE>//g;
      s/<\/PRE>//g;
     }
     push(@input,"$indent$_");
    }
   }
  }
 }
 close(DOC);
 &UnlockFile($lf1);
 $input=join('',@input);
 return($input);
}

sub PMCount{
#@_ = action, number
#This routine will increment or decrement the number after the heading or subheading
 my(@input,$count,$this);
 my($action,$amount)=@_;
#action = +,-
#amount = number
 if ($grandparent && $parent){
#If a title then work on the subheading file
  $lf1="$DISKNEWSPATH/$grandparent/smain.lock";
  $file1="$DISKNEWSPATH/$grandparent/smain.html";
 }
 else {
#If a subheading work on the heading file
  $lf1="$DISKNEWSPATH/hmain.lock";
  $file1="$DISKNEWSPATH/hmain.html";
 }
 &LockFile($lf1);
 open(DOC, "<$file1") || die "Can't open $file1: $!\n";
TOP: while(<DOC>){
#Search for ()
  if (/<!--$parent,/ && /<\/a> \((\d+)\)$/){
   $count=$1;
   if ($action eq "+" && $count >= 0){$count+=$amount;}
   elsif ($action eq "-" && $count > 0){$count-=$amount;}
   s/<\/a> \(\d+\)$/<\/a> \($count\)/;
   push(@input,$_);
   while(<DOC>){push(@input,$_);}
   last TOP;
  }
  else {push(@input,$_);}
 }
 close(DOC);
 open(DOC,">$file1") || die "Can't open $file1: $!\n";
 print DOC @input;
 close(DOC);
 &UnlockFile($lf1);
}

sub ARPassword{
#Add or remove a password to the file
#@_ = action, number
 my($action,$number)=@_;
 my(@input,$lf1,$file1,$index1);
 $lf1="$PASSWORDFILE.lock";
 $file1="$PASSWORDFILE";
 &LockFile($lf1);
 if ($action eq "+"){
#If it exists then concatenate it
  if(-e $file1){open(PWD,">>$file1") || die "Can't open concatenate $file1: $!\n";}
#Else just open it
  else {open(PWD,">$file1") || die "Can't open $file1: $!\n";}
  if($grandparent && $parent){
# Add a title password
   print PWD "$grandparent/$parent/$number\t$password\n";
  }
  elsif ($parent){
#Add a subheading password
   print PWD "$parent/$number/0\t$password\n";
  }
  else {
#Add a heading password
   print PWD "$number/0/0\t$password\n";
  }
  close(PWD);
 }
 else{
  open(PWD,"<$file1") || die "Can't open $file1: $!\n";
  if($grandparent && $parent){
# Remove a title password
   while(<PWD>){
    if(/^$grandparent\/$parent\/$number/){last;}
    else{push(@input,$_);}
   }
  }
  elsif ($parent){
#Remove a subheading password
   while(<PWD>){
    if(/^$parent\/$number\//){next;}
    else{push(@input,$_);}
   }
  }
  else {
#Remove a heading password
   while(<PWD>){
    if(/^$number\//){next;} 
    else{push(@input,$_);}
   }
  }
  while(<PWD>){push(@input,$_);}
  close(PWD);
  open(PWD,">$file1") || die "Can't open $file1: $!\n";
  print PWD @input;
  close(PWD);
 }
 &UnlockFile($lf1);
}

sub GetPassword{
#Get the password out of the password file
#@_ = number
 my($number)=@_;
 my($temp)=0;
 $lf1="$PASSWORDFILE.lock";
 $file1="$PASSWORDFILE";
 &LockFile($lf1);
 open(PWD,"<$file1") || die "Can't open $file1: $!\n";
 if($grandparent && $parent){
# Get a title password
  while(<PWD>){
   if(/^$grandparent\/$parent\/$number/){
    /\s+(.*)$/;
    $temp=$1;
    last;
   }
  }
 }
 elsif ($parent){
#Get a subheading password
  while(<PWD>){
   if(/^$parent\/$number\//){
    /\s+(.*)$/;
    $temp=$1;
    last;
   } 
  }
 }
 else {
#Get a heading password
  while(<PWD>){
   if(/^$number\//){
    /\s+(.*)$/;
    $temp=$1;
    last;
   }
  }
 }
 close(PWD);
 &UnlockFile($lf1);
 if($temp){return($temp);}
 else{return($MASTERPASSWORD);}
}

sub GetListing {
my($type)=@_;
#type = "full" ;get full listing
#type = "top" ;get just the top level listing
my($depth)=0;
@nl=();
@tl=();
%listarray={};
#This routine extracts information from the main files
 if($grandparent && $parent){
#Get a title listing
  $lf1="$DISKNEWSPATH/$grandparent/$parent/tmain.lock";
  $file1="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
 }
 elsif($parent){
#Get a subheading listing
  $lf1="$DISKNEWSPATH/$parent/smain.lock";
  $file1="$DISKNEWSPATH/$parent/smain.html";
 }
 else{
#Get a heading listing
  $lf1="$DISKNEWSPATH/hmain.lock";
  $file1="$DISKNEWSPATH/hmain.html";
 }
 &LockFile($lf1);
 open(DOC,"<$file1") || die "Can't open $file1: $!\n";
 if($type eq "full"){
TOP:  while(<DOC>){ 
   if(/<!--STOP-->/){
    last TOP;
   }
   elsif(/<!--(\d+),\d+-->(.+)<\/a>/){
#Get the numbers and the corresponding titles
    $listarray{$1}=$2;
    push(@nl,$1);
    push(@tl,$2);
   }
  }
  close(DOC);
  &UnlockFile($lf1);
 }
 else{ #Get the top level titles
TOP:  while(<DOC>){ 
   if(/<!--STOP-->/){
    last TOP;
   }
   elsif(/<UL>/){$depth++; next;}
   elsif(/<\/UL>/ && $depth > 0){$depth--; next;}
   if($depth==1 && /<!--(\d+),\d+-->(.+)<\/a>/){
#Get the numbers and the corresponding titles
    $listarray{$1}=$2;
    push(@nl,$1);
    push(@tl,$2);
    next;
   }
  }
  close(DOC);
  &UnlockFile($lf1);
 }
 if($todo eq "ADD"){
  $listarray{'0'}='(TOP)';
  unshift(@nl,'0');
  unshift(@tl,'(TOP)');
 }
 unless($#tl==$#nl){
  print "Critical error in $file1.<BR>\n";
  print "Please contact <a href=\"mailto:$MAINTAINEREMAIL\">$MAINTAINERNAME</a>.\n"; 
  exit;
 }
 return(\@nl,\@tl,\%listarray);
}

sub GetSList{
#Get a sound listing
#They should be in the format
#file.ext (tab/space) description
#The filenames should not have spaces
my($sinfo,$i);
my($file1)="$SOUNDINFO";
 $sinfo{'0'}='(NONE)';
 $sfiles[0]='0';
 open(DOC,"<$file1") || die"Cant open $file1: $!\n";
 while(<DOC>){
  if(/^\#/){next;}
  if(/^(\S+)\s+(.*)$/){
   $sinfo{"$1"}="$2";
   push(@sfiles,"$1");
  }
 }
 close(DOC);
 return(\%sinfo,\@sfiles);
}

sub GetOut{
#This routine is for writing information to disk if a suspected hacker
#is attempting to gain access and send email to MAINTAINEREMAIL
open(DOC,">>$HACKERLOG") || die "Can't open $HACKERLOG: $!\n";
print DOC "=========================$ezdate=========================\n";
while(($first,$last)=each(%ENV)) {print DOC "$first = $last\n";}
print DOC $query->dump."\n";
close(DOC);
print $query->header(-target=>'arwindow');
print <<END;
<title>Intuder Alert</title>
<center><blink><H1>Intruder Alert</H1></blink></center>
Hello,<BR>
For some reason your form has submitted VERY questionable values.
If you feel that you have received this message by error please
try again or contact <a href="mailto:$MAINTAINEREMAIL">$MAINTAINERNAME</a>.<BR>
Thank You,<BR>
VBS Author<P>
P.S. Your personal information has been passed on to the proper authorities:<P>
END
print "<B>Your Personal Information:</B><BR>",
	"Remote Address = ",
	$ENV{REMOTE_ADDR},
	"<BR>\n",
	"Remote Hostname = ",
	$ENV{REMOTE_HOST},
	"<BR>\n",
	"Referring Document = ",
	$ENV{HTTP_REFERER},
	"<BR>\n",
	"<B>The values you passed to me:</B><BR>\n",
	$query->dump,
	"\n";
sleep 3;
&Bomb();
#Send mail if they want it.
if ($MAILNOTIFY){
 open (MAIL, "|$MAILPROGRAM $MAINTAINEREMAIL") || die "Can't open $MAILPROGRAM: $!\n";
 print MAIL "To: $MAINTAINEREMAIL\n",
	"From: VBS1.0\n",
	"Subject: Intruder Alert - Possible Hacker\n\n",
	"Hello,\n",
	"   There is a possible hacker trying to get in through VBS $version.\n",
	"Please see the file $HACKERLOG located at\n",
	"$HTTPADDRESS for more information.\n";
 close(MAIL);
 }
}
 
sub ThankYou{
#Print out a thank you message
 if($grandparent && $parent){
#Print out title reload
  if($todo eq "ADD"){
   $temp="alert(\"\\nThank You.\\n\\nYour message/URL has been added.\"\n)";
   $temp.=<<END;
opener.top.frames[3].location.reload(1);
opener.top.frames[2].location.reload(1);
self.close();
END
  }
  elsif($todo eq "REMOVE"){
   $temp="alert(\"\\nThank You.\\n\\nYour message/URL has been removed.\"\n)";
   $temp.=<<END;
opener.top.frames[3].location.reload(1);
opener.top.frames[2].location.reload(1);
self.close();
END
  }
  elsif($todo eq "EDIT"){
   $temp="alert(\"\\nThank You.\\n\\nYour message/URL has been edited.\"\n)";
   $temp.=<<END;
opener.top.frames[3].location.reload(1);
opener.top.frames[2].location.reload(1);
self.close();
END
  }
  elsif($todo eq "REPLY"){
   $temp=<<END;
var msg="\\nThank You.\\n\\nYour message/URL has been added.\\n\\n";
alert(msg);
opener.opener.top.frames[3].location.reload(1);
opener.opener.top.frames[2].location.reload(1);
opener.opener.top.self.focus();
self.close();
END
  }
 }
 elsif($parent){
#Print out subhead reload
  if($todo eq "ADD"){
   $temp=<<END;
var msg="\\nThank you.\\n\\nYour subheading has been added.";
END
  }
  elsif($todo eq "REMOVE"){
   $temp=<<END;
var msg="\\nThank you.\\n\\nYour subheading has been removed.";
END
  }
  elsif($todo eq "EDIT"){
   $temp=<<END;
var msg="\\nThank you.\\n\\nYour subheading has been edited.";
END
  }
  $temp.=<<END;
alert(msg);
opener.top.frames[3].document.write("<P><BR>\\n");
opener.top.frames[2].location.reload(1);
opener.top.frames[1].location.reload(1);
self.close();
END
 }
 else {
#Print out head reload
  if($todo eq "ADD"){
   $temp=<<END;
var msg="\\nThank you.\\n\\nYour heading has been added.";
END
  }
  elsif($todo eq "REMOVE"){
   $temp=<<END;
var msg="\\nThank you.\\n\\nYour heading has been removed.";
END
  }
  elsif($todo eq "EDIT"){
   $temp=<<END;
var msg="\\nThank you.\\n\\nYour heading has been edited.";
END
  }
  $temp.=<<END;
alert(msg);
opener.top.frames[2].document.write("<P><BR>\\n");
opener.top.frames[3].document.write("<P><BR>\\n");
opener.top.frames[1].location.reload(1);
self.close();
END
 }
 if(!$UPDATED){print $query->header(-target=>'arwindow');}
 print "<script>$temp</script>",
	$query->end_html;
}

sub Update{
#Update the appropriate file and remove stale titles
 my($temp,$i,@listing,$this);
 if($grandparent && $parent){
#get tile listings
  $lf1="$DISKNEWSPATH/$grandparent/$parent/tmain.lock";
  $file1="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
  $time2=$ttime;
 }
 elsif($parent){
#get subtitle listings
  $lf1="$DISKNEWSPATH/$parent/smain.lock";
  $file1="$DISKNEWSPATH/$parent/smain.html";
  $time2=$stime;
 }
 else{
#get head listings
  $lf1="$DISKNEWSPATH/hmain.lock";
  $file1="$DISKNEWSPATH/hmain.html";
  $time2=$htime;
 }
 (@numlist,@titlelist,%listarray)=&GetListing('full');
 &LockFile($lf1);
 open(DOC,"<$file1") || die "Can't open $file1: $!\n";
 while(<DOC>){
#Search for times of additions
  if(/<!--(\d+),(\d+)-->/){  #<!--added file,time of addition-->
   $getridof = "$1";
   $time3=$time1-$2;  #current time - time was saved
   if($time3 > $time2){ 
    push(@listings,"$getridof");
   }
  }
 }
 close(DOC);
 &UnlockFile($lf1);
#Removed stale listings
 if($#listing+1){
  $UPDATED=1;
  print $query->header(-target=>'arwindow'),
	$query->start_html(-title=>'Removing Stale Additions');
  foreach $this (@listing){
   &Remove($this);
   &RemoveChild($this);
   &ARPassword('-',$this);
   print "<B>Removed Stale Title:</B> ",
	$listarray{$this},
	"<BR>\n";
  }
  PMCount('-',$#listing+1);
 }
}

sub MakeChild{
#@_ = grandparent, parent (These are the childs grandparent and parent)
#This routine will make the child.
 my($grandparent,$parent)=@_;
 my($parentname,$tpmain,$tpbuttons,$nmain,$nbuttons,$base,$target);
 my($winopts,$script,$file1,$file2,$file3);
 my($index,$main,$buttons,$filter);
 if($grandparent){
  $grandparent=~/(\d+)/;
  $grandparent=$1;
 }
 if($parent){
  $parent=~/(\d+)/;
  $parent=$1;
 }
 if($grandparent && $parent){
# Build a title because both are defined
  mkdir("$DISKNEWSPATH/$grandparent/$parent",0775);
  chmod 0775, "$DISKNEWSPATH/$grandparent/$parent";
  chown $uid, $gid, "$DISKNEWSPATH/$grandparent/$parent";
  $parentname="$subhead";
  $type="Title";
  $tpmain="tmain.html";
  $tpbuttons="tbuttons.html";
  $nmain="tmain";
  $nbuttons="tbuttons";
  $base="$HTTPADDRESS/$WEBNEWSPATH/$grandparent/$parent/";
  $target="main";
  $winopts="width=580,height=380,menubar=1,status=1,scrollbars=1";
  $script="$TSCRIPT";
  $filter="1";
  $file1="$DISKNEWSPATH/$grandparent/$parent/$INDEXFILE";
  $file2="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
  $file3="$DISKNEWSPATH/$grandparent/$parent/tbuttons.html";
 }
 elsif ($parent){
#Build a subheading because only parent is defined
  mkdir("$DISKNEWSPATH/$parent",0775);
  chmod 0775, "$DISKNEWSPATH/$parent";
  chown $uid, $gid, "$DISKNEWSPATH/$parent";
  $parentname="$head";
  $type="Subheading";
  $tpmain="smain.html";
  $tpbuttons="sbuttons.html";
  $nmain="smain";
  $nbuttons="sbuttons";
  $base="$HTTPADDRESS/$WEBNEWSPATH/$parent/";
  $target="titles";
  $winopts="width=500,height=250,status=1,menubar=1,scrollbars=1";
  $todotype="SUBHEAD";
  $script="$SSCRIPT";
  $file1="$DISKNEWSPATH/$parent/$INDEXFILE";
  $file2="$DISKNEWSPATH/$parent/smain.html";
  $file3="$DISKNEWSPATH/$parent/sbuttons.html";
 }
 else {
#Build a heading because neither are defined
  $parentname="Top Level";
  $type="Heading";
  $tpmain="hmain.html";
  $tpbuttons="hbuttons.html";
  $nmain="hmain";
  $nbuttons="hbuttons";
  $base="$HTTPADDRESS/$WEBNEWSPATH/";
  $target="subheadings";
  $winopts="width=500,height=250,status=1,menubar=1,scrollbars=1";
  $todotype="HEAD";
  $script="$HSCRIPT";
  $file1="$DISKNEWSPATH/hindex.html";
  $file2="$DISKNEWSPATH/hmain.html";
  $file3="$DISKNEWSPATH/hbuttons.html";
 }

 $index=<<END;
<HTML> 
<HEAD>
</HEAD> 
<FRAMESET ROWS="4*,*" BORDER=3 FRAMESPACING=0>
 <FRAME NAME="$nmain" SRC="$base$tpmain" MARGINWIDTH="1" MARGINHEIGHT="1" NORESIZE>
 <FRAME NAME="$nbuttons" SRC="$base$tpbuttons" SCROLLING="no" MARGINWIDTH="1" MARGINHEIGHT="1" NORESIZE>
</FRAMESET>
</HTML>
END
 
 $main=<<END;
<HTML>
<HEAD>
</HEAD>
<BODY BGCOLOR="$BGCOLOR" TEXT="$TEXTCOLOR" BACKGROUND="$BACKGROUND"
      LINK="$LINKCOLOR" VLINK="$VLINKCOLOR" ALINK="$ALINKCOLOR"
	onLoad="self.focus();">
<BASE target="$target">
<Center><B>$parentname</B></Center>
<Font Size="-1">
<!--START-->
<UL>
</UL>
<!--STOP-->
</font>
END

 $buttons=<<END;
<HEAD>
<SCRIPT LANGUAGE="JavaScript">
<!--
function sub(action,type){
 top.arwindow = window.open("","arwindow","$winopts")
 top.arwindow.document.write("<title>"+type+"</title>")
 top.arwindow.document.write("<H1>Please wait one moment</H1>")
 document.arform.todo.value=action;
 document.arform.submit();
}
//-->
</SCRIPT>
</HEAD>
<BODY BGCOLOR="$BGCOLOR" TEXT="$TEXTCOLOR" BACKGROUND="$BACKGROUND"
      LINK="$LINKCOLOR" VLINK="$VLINKCOLOR" ALINK="$ALINKCOLOR">
<FORM METHOD="$METHOD" ACTION="$script" TARGET="arwindow" NAME="arform">
<input type="hidden" name="grandparent" value="$grandparent">
<input type="hidden" name="parent" value="$parent">
<input type="hidden" name="boardname" value="$BOARDNAME">
<input type="hidden" name="todo" value="">
END
 if($todotype eq "HEAD" || $todotype eq "SUBHEAD"){
  $buttons.=<<END;
<input type="hidden" name="todotype" value="$todotype">
END
 }
 $buttons.="</FORM><center>";
 if($filter){
  $buttons.=<<END;
<table cols="4" cellpadding="1" cellspacing="1" width="90%" border="0">
END
}
 else{
  $buttons.=<<END;
<table cols="3" cellpadding="1" cellspacing="1" width="90%" border="0">
END
}
 $buttons.=<<END;
<TH align="left" valign="middle">
<font size="-1"><a href="#" onClick="sub('ADD','Add a $type');">
Add a $type
</a></font>
</TH>
<TH valign="middle">
<font size="-1"><a href="#" onClick="sub('EDIT','Edit a $type');">
Edit
</a></font>
</TH>
END
 if($filter){
 $buttons.=<<END;
<TH align="center" valign="middle">
<font size="-1"><a href="#" onClick="sub('FILTER','Filter these titles');">
Filter Messages
</a></font>
</TH>
END
 }
$buttons.=<<END;
<TH align="right" valign="middle">
<font size="-1"><a href="#" onClick="sub('REMOVE','Remove a $type');">
Remove a $type
</a></font>
</TH>
</table>
</center>
END
#Print out the documents
 open(DOC, ">$file1") || die "Can't open $file1: $!\n";
 print DOC "$index";
 close(DOC);
 open(DOC, ">$file2") || die "Can't open $file2: $!\n";
 print DOC "$main";
 close(DOC);
 open(DOC, ">$file3") || die "Can't open $file3: $!\n";
 print DOC "$buttons";
 close(DOC);
 chmod 0664, "$file1", "$file2", "$file3";
 chown $uid, $gid, "$file1", "$file2", "$file3";
}

#This routine will remove a child from the drive
sub RemoveChild{
#Remove the child and stuff
 my($rmnumber)=@_;
 if ($grandparent && $parent){
#Remove a title
  unlink <$DISKNEWSPATH/$grandparent/$parent/$rmnumber.*>;
 }
 elsif($parent){
#Remove a Subheading
  unlink "$DISKNEWSPATH/$parent/$rmnumber/$INDEXFILE";
  system "rm -r $DISKNEWSPATH/$parent/$rmnumber/*";
  rmdir "$DISKNEWSPATH/$parent/$rmnumber";
 }
 else{
#Remove a heading
  unlink "$DISKNEWSPATH/$rmnumber/$INDEXFILE";
  system "rm -r $DISKNEWSPATH/$rmnumber/*";
  rmdir "$DISKNEWSPATH/$rmnumber";
 }
}

sub DontKnow {
 print $query->header(-target=>'arwindow'),
	$query->start_html(-title=>"I Don't Know What To Do"),
	"<CENTER><H1>I Don't Know What To Do!</H1></CENTER>\n",
	$query->end_html;
 exit;
}

sub Filter {
 $lf1="$DISKNEWSPATH/$grandparent/$parent/tmain.lock";
 $file1="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
 @inputdate=($abmonth,$abday,$abyear);
 $inputdate="$inputdate[0]/$inputdate[1]/$inputdate[2]";
 &LockFile($lf1);
 open(DOC, "<$file1") || die "Can't open $file1: $!\n";
 while(<DOC>){
  if(/^<!--START-->$/){
   if($tfilter eq "contains"){
    $tempin="<CENTER><B>Messages that CONTAIN \"$contains\"</B></CENTER><BR>\n";
    push(@input,$_,$tempin);
    while(<DOC>){
     if(m~$contains~ || m~^<UL>~ || m~^</UL>~){
      push(@input,$_);
      next;
     }
    }
   }
   elsif($tfilter=~/^[abo]date$/){
    if($tfilter eq "bdate"){
     $tempin="<CENTER><B>Messages ON or BEFORE $inputdate</B></CENTER><BR>\n"; 
    }
    elsif($tfilter eq "odate"){
     $tempin="<CENTER><B>Messages ON $inputdate</B></CENTER><BR>\n"; 
    }
    elsif($tfilter eq "adate"){
     $tempin="<CENTER><B>Messages ON or AFTER $inputdate</B></CENTER><BR>\n"; 
    }
    push(@input,$_,$tempin);
    while(<DOC>){
     if(m~</a> (\d+)/(\d+)/(\d+) at ~){
      @olddate=($1,$2,$3);
      @comp1=($inputdate[0]==$olddate[0],$inputdate[1]==$olddate[1],$inputdate[2]==$olddate[2]);
      @comp2=($inputdate[0]>=$olddate[0],$inputdate[1]>=$olddate[1],$inputdate[2]>=$olddate[2]);
      @comp3=($inputdate[0]<=$olddate[0],$inputdate[1]<=$olddate[1],$inputdate[2]<=$olddate[2]);
      if($tfilter eq "bdate" && $comp2[0] && $comp2[1] && $comp2[2]){
       push(@input,$_);
       next;
      }  
      elsif($tfilter eq "odate" && $comp1[0] && $comp1[1] && $comp1[2]){
       push(@input,$_);
       next;
      }
      elsif($tfilter eq "adate" && $comp2[0] && $comp2[1] && $comp2[2]){
       push(@input,$_);
       next;
      }
     }
     else{push(@input,$_);next;}
    }
   }
  } 
  else{push(@input,$_);next;}
 }
 close(DOC);
 &UnlockFile($lf1);
 print $query->header(-target=>'tmain'),
	@input;
 return;
}
sub Change {
#@_[0] = Number to be edited
#@_[1] = New edited title
 my($ednumber,$edited)=@_;
#This routine extracts information from the main files
 if($grandparent && $parent){
#Get a title listing
  $lf1="$DISKNEWSPATH/$grandparent/$parent/tmain.lock";
  $file1="$DISKNEWSPATH/$grandparent/$parent/tmain.html";
 }
 elsif($parent){
#Get a subheading listing
  $lf1="$DISKNEWSPATH/$parent/smain.lock";
  $file1="$DISKNEWSPATH/$parent/smain.html";
 }
 else{
#Get a heading listing
  $lf1="$DISKNEWSPATH/hmain.lock";
  $file1="$DISKNEWSPATH/hmain.html";
 }
 &LockFile($lf1);
 open(DOC,"<$file1") || die "Can't open $file1: $!\n";
TOP:  while(<DOC>){ 
  if(/<!--STOP-->/){
   push(@input,$_);
   last TOP;
  }
  elsif(/<!--$ednumber,\d+-->.+<\/a>/){
   s/<!--$ednumber,(\d+)-->.+<\/a>/<!--$ednumber,$1-->$edited<\/a>/;
   push(@input,$_);
   $changed=1;
   last TOP;
  }
  else{push(@input,$_);}
 }
 while(<DOC>){push(@input,$_);}
 close(DOC);
 open(DOC,">$file1") || die "Can't open $file1: $!\n";
 print DOC @input;
 close(DOC);
 &UnlockFile($lf1);
 if($changed){return(1);}
 else{return(0);}
}

#I know this software is free, but please don't change
#the following.
$version="v5.0";
$MYNAME="Brad Daugherty";
$MYMAIL="bsd\@pobox.com";
$MYWEB="http://www.pobox.com/~bsd";
$METHOD="POST";

